#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;
uniform float power;
uniform float desaturate;
uniform int tonemap_method;

vec3 tonemap(vec3 c)
{
	if(tonemap_method==0){
		return clamp(c,0.0,1.0);
	}else{
		return vec3(1.0,1.0,1.0)-exp(-max(1.5*c,0.0));
	}
}

void main()
{
	vec3 col=texture2D(my_color_texture, texture_coordinate).rgb;
	col=clamp(col, 0.0, 10000.0);
	//col=col*(sin(col)*0.5+0.5);
	vec3 col_p=vec3(pow(col.r, power), pow(col.g, power), pow(col.b, power));
	float a=(desaturate*col_p.r+desaturate*col_p.g+desaturate*col_p.b)*(1.0/3.0);
	col_p=col_p*(1.0-desaturate)+vec3(a,a,a);
	//gl_FragColor = vec4(clamp(col_p*gl_Color.rgb,0.0,1.0), 1.0);
	gl_FragColor = vec4(tonemap(col_p*gl_Color.rgb), 1.0);
}
